Contents Up << >>

## wxWindow

wxWindow is the base class for all windows. Any children of the window will be deleted automatically by the destructor before the window itself is deleted.

Derived from

wxEvtHandler
wxObject

Include files

<wx/window.h>

Window styles

The following styles can apply to all windows, although they will not always make sense for a particular window class.

wxSIMPLE_BORDER | Displays a thin border around the window. wxBORDER is the old name for this style.
wxDOUBLE_BORDER | Displays a double border. Windows only.
wxSUNKEN_BORDER | Displays a sunken border.
wxRAISED_BORDER | Displays a raised border.
wxSTATIC_BORDER | Displays a border suitable for a static control.
wxTRANSPARENT_WINDOW | The window is transparent, that is, it will not receive paint events. Windows only.
wxNO_3D | Prevents the children of this window taking on 3D styles, even though the application-wide policy is for 3D controls. Windows only.
wxTAB_TRAVERSAL | Use this to enable tab traversal for non-dialog windows.
wxVSCROLL | Use this style to enable a vertical scrollbar.
wxHSCROLL | Use this style to enable a horizontal scrollbar.
wxCLIP_CHILDREN | Use this style to eliminate flicker caused by the background being repainted, then children being painted over them. Windows-only.

See also window styles overview.

See also

Event handling overview

Members

wxWindow::wxWindow
wxWindow::~wxWindow
wxWindow::AddChild
wxWindow::CaptureMouse
wxWindow::Center
wxWindow::Centre
wxWindow::Clear
wxWindow::ClientToScreen
wxWindow::Close
wxWindow::ConvertDialogToPixels
wxWindow::ConvertPixelsToDialog
wxWindow::Destroy
wxWindow::DestroyChildren
wxWindow::DragAcceptFiles
wxWindow::Enable
wxWindow::FindFocus
wxWindow::FindWindow
wxWindow::Fit
wxWindow::GetBackgroundColour
wxWindow::GetCharHeight
wxWindow::GetCharWidth
wxWindow::GetChildren
wxWindow::GetClientSize
wxWindow::GetConstraints
wxWindow::GetDefaultItem
wxWindow::GetDropTarget
wxWindow::GetEventHandler
wxWindow::GetFont
wxWindow::GetForegroundColour
wxWindow::GetGrandParent
wxWindow::GetHandle
wxWindow::GetId
wxWindow::GetPosition
wxWindow::GetLabel
wxWindow::GetName
wxWindow::GetParent
wxWindow::GetRect
wxWindow::GetReturnCode
wxWindow::GetScrollThumb
wxWindow::GetScrollPos
wxWindow::GetScrollRange
wxWindow::GetSize
wxWindow::GetTextExtent
wxWindow::GetTitle
wxWindow::GetUpdateRegion
wxWindow::GetWindowStyleFlag
wxWindow::InitDialog
wxWindow::IsEnabled
wxWindow::IsRetained
wxWindow::IsShown
wxWindow::Layout
wxWindow::LoadFromResource
wxWindow::Lower
wxWindow::MakeModal
wxWindow::Move
wxWindow::OnActivate
wxWindow::OnChar
wxWindow::OnCharHook
wxWindow::OnCommand
wxWindow::OnClose
wxWindow::OnCloseWindow
wxWindow::OnDropFiles
wxWindow::OnEraseBackground
wxWindow::OnKeyDown
wxWindow::OnKeyUp
wxWindow::OnKillFocus
wxWindow::OnIdle
wxWindow::OnInitDialog
wxWindow::OnMenuCommand
wxWindow::OnMenuHighlight
wxWindow::OnMouseEvent
wxWindow::OnMove
wxWindow::OnPaint
wxWindow::OnScroll
wxWindow::OnSetFocus
wxWindow::OnSize
wxWindow::OnSysColourChanged
wxWindow::PopEventHandler
wxWindow::PopupMenu
wxWindow::PushEventHandler
wxWindow::Raise
wxWindow::Refresh
wxWindow::ReleaseMouse
wxWindow::RemoveChild
wxWindow::ScreenToClient
wxWindow::ScrollWindow
wxWindow::SetAcceleratorTable
wxWindow::SetAutoLayout
wxWindow::SetBackgroundColour
wxWindow::SetClientSize
wxWindow::SetCursor
wxWindow::SetEventHandler
wxWindow::SetConstraints
wxWindow::SetDropTarget
wxWindow::SetFocus
wxWindow::SetFont
wxWindow::SetForegroundColour
wxWindow::SetId
wxWindow::SetName
wxWindow::SetPalette
wxWindow::SetReturnCode
wxWindow::SetScrollbar
wxWindow::SetScrollPos
wxWindow::SetSize
wxWindow::SetSizeHints
wxWindow::SetTitle
wxWindow::Show
wxWindow::TransferDataFromWindow
wxWindow::TransferDataToWindow
wxWindow::Validate
wxWindow::WarpPointer

### wxWindow::wxWindow

wxWindow()

Default constructor.

wxWindow(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxPanelNameStr)

Constructs a window, which can be a child of a frame, dialog or any other non-control window.

Parameters

parent

Pointer to a parent window.

id

Window identifier. If -1, will automatically create an identifier.

pos

Window position. wxDefaultPosition is (-1, -1) which indicates that wxWidgets should generate a default position for the window. If using the wxWindow class directly, supply an actual position.

size

Window size. wxDefaultSize is (-1, -1) which indicates that wxWidgets should generate a default size for the window.

style

Window style. For generic window styles, please see wxWindow.

name

Window name.

### wxWindow::~wxWindow

~wxWindow()

Destructor. Deletes all subwindows, then deletes itself. Instead of using the delete operator explicitly, you should normally use wxWindow::Destroy so that wxWidgets can delete a window only when it is safe to do so, in idle time.

See also

Window deletion overview, wxWindow::OnCloseWindow, wxWindow::Destroy, wxCloseEvent

### wxWindow::AddChild

virtual void AddChild(wxWindow* child)

Adds a child window. This is called automatically by window creation functions so should not be required by the application programmer.

Parameters

child

Child window to add.

### wxWindow::CaptureMouse

virtual void CaptureMouse()

Directs all mouse input to this window. Call wxWindow::ReleaseMouse to release the capture.

See also

wxWindow::ReleaseMouse

### wxWindow::Center

void Center(int direction)

A synonym for Centre.

### wxWindow::Centre

virtual void Centre(int direction = wxHORIZONTAL)

Centres the window.

Parameters

direction

Specifies the direction for the centering. May be `wxHORIZONTAL`, `wxVERTICAL` or `wxBOTH`.

Remarks

The actual behaviour depends on the derived window. For a frame or dialog box, centring is relative to the whole display. For a panel item, centring is relative to the panel.

See also

wxWindow::Center

### wxWindow::Clear

void Clear()

Clears the window by filling it with the current background colour. Does not cause an erase background event to be generated.

### wxWindow::ClientToScreen

virtual void ClientToScreen(int* x, int* y) const

virtual wxPoint ClientToScreen(const wxPoint& pt) const

Converts to screen coordinates from coordinates relative to this window.

x

A pointer to a integer value for the x coordinate. Pass the client coordinate in, and a screen coordinate will be passed out.

y

A pointer to a integer value for the y coordinate. Pass the client coordinate in, and a screen coordinate will be passed out.

pt

The client position for the second form of the function.

wxPython note:
In place of a single overloaded method name, wxPython implements the following methods:

ClientToScreen(point) | Accepts and returns a wxPoint
ClientToScreenXY(x, y) | Returns a 2-tuple, (x, y)

### wxWindow::Close

virtual bool Close(const bool force = FALSE)

The purpose of this call is to provide a safer way of destroying a window than using the delete operator.

Parameters

force

FALSE if the window's close handler should be able to veto the destruction of this window, TRUE if it cannot.

Remarks

Close calls the close handler for the window, providing an opportunity for the window to choose whether to destroy the window.

The close handler should check whether the window is being deleted forcibly, using wxCloseEvent::GetForce, in which case it should destroy the window using wxWindow::Destroy.

Applies to managed windows (wxFrame and wxDialog classes) only.

Note that calling Close does not guarantee that the window will be destroyed; but it provides a way to simulate a manual close of a window, which may or may not be implemented by destroying the window. The default implementation of wxDialog::OnCloseWindow does not necessarily delete the dialog, since it will simply simulate an wxID_CANCEL event which itself only hides the dialog.

To guarantee that the window will be destroyed, call wxWindow::Destroy instead.

See also

Window deletion overview, wxWindow::OnCloseWindow, wxWindow::Destroy, wxCloseEvent

### wxWindow::ConvertDialogToPixels

wxPoint ConvertDialogToPixels(const wxPoint& pt)

wxSize ConvertDialogToPixels(const wxSize& sz)

Converts a point or size from dialog units to pixels.

For the x dimension, the dialog units are multiplied by the average character width and then divided by 4.

For the y dimension, the dialog units are multiplied by the average character height and then divided by 8.

Remarks

Dialog units are used for maintaining a dialog's proportions even if the font changes. Dialogs created using Dialog Editor optionally use dialog units.

You can also use these functions programmatically. A convenience macro is defined:

    #define wxDLG_UNIT(parent, pt) parent->ConvertDialogToPixels(pt)

See also

wxWindow::ConvertPixelsToDialog

wxPython note:
In place of a single overloaded method name, wxPython implements the following methods:

ConvertDialogPointToPixels(point) | Accepts and returns a wxPoint
ConvertDialogSizeToPixels(size) | Accepts and returns a wxSize

Additionally, the following helper functions are defined:

wxDLG_PNT(win, point) | Converts a wxPoint from dialog units to pixels
wxDLG_SZE(win, size) | Converts a wxSize from dialog units to pixels

### wxWindow::ConvertPixelsToDialog

wxPoint ConvertPixelsToDialog(const wxPoint& pt)

wxSize ConvertPixelsToDialog(const wxSize& sz)

Converts a point or size from pixels to dialog units.

For the x dimension, the pixels are multiplied by 4 and then divided by the average character width.

For the y dimension, the pixels are multipled by 8 and then divided by the average character height.

Remarks

Dialog units are used for maintaining a dialog's proportions even if the font changes. Dialogs created using Dialog Editor optionally use dialog units.

See also

wxWindow::ConvertDialogToPixels

wxPython note:
In place of a single overloaded method name, wxPython implements the following methods:

ConvertDialogPointToPixels(point) | Accepts and returns a wxPoint
ConvertDialogSizeToPixels(size) | Accepts and returns a wxSize

### wxWindow::Destroy

virtual bool Destroy()

Destroys the window safely. Use this function instead of the delete operator, since different window classes can be destroyed differently. Frames and dialogs are not destroyed immediately when this function is called - they are added to a list of windows to be deleted on idle time, when all the window's events have been processed. This prevents problems with events being sent to non-existant windows.

Return value

TRUE if the window has either been successfully deleted, or it has been added to the list of windows pending real deletion.

### wxWindow::DestroyChildren

virtual void DestroyChildren()

Destroys all children of a window. Called automatically by the destructor.

### wxWindow::DragAcceptFiles

virtual void DragAcceptFiles(const bool accept)

Enables or disables elibility for drop file events (OnDropFiles).

Parameters

accept

If TRUE, the window is eligible for drop file events. If FALSE, the window will not accept drop file events.

Remarks

Windows only.

See also

wxWindow::OnDropFiles

### wxWindow::Enable

virtual void Enable(const bool enable)

Enable or disable the window for user input.

Parameters

enable

If TRUE, enables the window for input. If FALSE, disables the window.

See also

wxWindow::IsEnabled

### wxWindow::FindFocus

static wxWindow* FindFocus()

Finds the window or control which currently has the keyboard focus.

Remarks

Note that this is a static function, so it can be called without needing a wxWindow pointer.

See also

wxWindow::SetFocus

### wxWindow::FindWindow

wxWindow* FindWindow(long id)

Find a child of this window, by identifier.

wxWindow* FindWindow(const wxString& name)

Find a child of this window, by name.

wxPython note:
In place of a single overloaded method name, wxPython implements the following methods:

FindWindowById(id) | Accepts an integer
FindWindowByName(name) | Accepts a string

### wxWindow::Fit

virtual void Fit()

Sizes the window so that it fits around its subwindows.

### wxWindow::GetBackgroundColour

virtual wxColour GetBackgroundColour() const

Returns the background colour of the window.

See also

wxWindow::SetBackgroundColour, wxWindow::SetForegroundColour, wxWindow::GetForegroundColour, wxWindow::OnEraseBackground

### wxWindow::GetCharHeight

virtual int GetCharHeight() const

Returns the character height for this window.

### wxWindow::GetCharWidth

virtual int GetCharWidth() const

Returns the average character width for this window.

### wxWindow::GetChildren

wxList& GetChildren()

Returns a reference to the list of the window's children.

### wxWindow::GetClientSize

virtual void GetClientSize(int* width, int* height) const

virtual wxSize GetClientSize() const

This gets the size of the window 'client area' in pixels. The client area is the area which may be drawn on by the programmer, excluding title bar, border etc.

Parameters

width

Receives the client width in pixels.

height

Receives the client height in pixels.

wxPython note:
In place of a single overloaded method name, wxPython implements the following methods:

wxGetClientSizeTuple() | Returns a 2-tuple of (width, height)
wxGetClientSize() | Returns a wxSize object

### wxWindow::GetConstraints

wxLayoutConstraints* GetConstraints() const

Returns a pointer to the window's layout constraints, or NULL if there are none.

### wxWindow::GetDefaultItem

wxButton* GetDefaultItem() const

Returns a pointer to the button which is the default for this window, or NULL.

### wxWindow::GetDropTarget

wxDropTarget* GetDropTarget() const

Returns the associated drop target, which may be NULL.

See also

wxWindow::SetDropTarget, Drag and drop overview

### wxWindow::GetEventHandler

wxEvtHandler* GetEventHandler() const

Returns the event handler for this window. By default, the window is its own event handler.

See also

wxWindow::SetEventHandler, wxWindow::PushEventHandler, wxWindow::PopEventHandler, wxEvtHandler::ProcessEvent, wxEvtHandler

### wxWindow::GetFont

wxFont& GetFont() const

Returns a reference to the font for this window.

See also

wxWindow::SetFont

### wxWindow::GetForegroundColour

virtual wxColour GetForegroundColour()

Returns the foreground colour of the window.

Remarks

The interpretation of foreground colour is open to interpretation according to the window class; it may be the text colour or other colour, or it may not be used at all.

See also

wxWindow::SetForegroundColour, wxWindow::SetBackgroundColour, wxWindow::GetBackgroundColour

### wxWindow::GetGrandParent

wxWindow* GetGrandParent() const

Returns the grandparent of a window, or NULL if there isn't one.

### wxWindow::GetHandle

void* GetHandle() const

Returns the platform-specific handle of the physical window. Cast it to an appropriate handle, such as HWND for Windows or Widget for Motif.

### wxWindow::GetId

int GetId() const

Returns the identifier of the window.

Remarks

Each window has an integer identifier. If the application has not provided one, an identifier will be generated.

See also

wxWindow::SetId Window identifiers

### wxWindow::GetPosition

virtual void GetPosition(int* x, int* y) const

This gets the position of the window in pixels, relative to the parent window or if no parent, relative to the whole display.

Parameters

x

Receives the x position of the window.

y

Receives the y position of the window.

wxPython note:
In place of a single overloaded method name, wxPython implements the following methods:

GetPosition() | Returns a wxPoint
GetPositionTuple() | Returns a tuple (x, y)

### wxWindow::GetLabel

virtual wxString& GetLabel() const

Generic way of getting a label from any window, for identification purposes.

Remarks

The interpretation of this function differs from class to class. For frames and dialogs, the value returned is the title. For buttons or static text controls, it is the button text. This function can be useful for meta-programs (such as testing tools or special-needs access programs) which need to identify windows by name.

### wxWindow::GetName

virtual wxString& GetName() const

Returns the window's name.

Remarks

This name is not guaranteed to be unique; it is up to the programmer to supply an appropriate name in the window constructor or via wxWindow::SetName.

See also

wxWindow::SetName

### wxWindow::GetParent

virtual wxWindow* GetParent() const

Returns the parent of the window, or NULL if there is no parent.

### wxWindow::GetRect

virtual wxRect GetRect() const

Returns the size and position of the window as a wxRect object.

### wxWindow::GetReturnCode

int GetReturnCode()

Gets the return code for this window.

Remarks

A return code is normally associated with a modal dialog, where wxDialog::ShowModal returns a code to the application.

See also

wxWindow::SetReturnCode, wxDialog::ShowModal, wxDialog::EndModal

### wxWindow::GetScrollThumb

virtual int GetScrollThumb(int orientation)

Returns the built-in scrollbar thumb size.

See also

wxWindow::SetScrollbar

### wxWindow::GetScrollPos

virtual int GetScrollPos(int orientation)

Returns the built-in scrollbar position.

See also

See wxWindow::SetScrollbar

### wxWindow::GetScrollRange

virtual int GetScrollRange(int orientation)

Returns the built-in scrollbar range.

See also

wxWindow::SetScrollbar

### wxWindow::GetSize

virtual void GetSize(int* width, int* height) const

virtual wxSize GetSize() const

This gets the size of the entire window in pixels.

Parameters

width

Receives the window width.

height

Receives the window height.

wxPython note:
In place of a single overloaded method name, wxPython implements the following methods:

GetSize() | Returns a wxSize
GetSizeTuple() | Returns a 2-tuple (width, height)

### wxWindow::GetTextExtent

virtual void GetTextExtent(const wxString& string, int* x, int* y, int* descent = NULL, int* externalLeading = NULL, const wxFont* font = NULL, const bool use16 = FALSE) const

Gets the dimensions of the string as it would be drawn on the window with the currently selected font.

Parameters

string

String whose extent is to be measured.

x

Return value for width.

y

Return value for height.

descent

Return value for descent (optional).

externalLeading

Return value for external leading (optional).

font

Font to use instead of the current window font (optional).

use16

If TRUE, string contains 16-bit characters. The default is FALSE.

wxPython note:
In place of a single overloaded method name, wxPython implements the following methods:

GetTextExtent(string) | Returns a 2-tuple, (width, height)
GetFullTextExtent(string, font=NULL) | Returns a 4-tuple, (width, height, descent, externalLeading)

### wxWindow::GetTitle

virtual wxString GetTitle()

Gets the window's title. Applicable only to frames and dialogs.

See also

wxWindow::SetTitle

### wxWindow::GetUpdateRegion

virtual wxRegion GetUpdateRegion() const

Returns the region specifying which parts of the window have been damaged. Should only be called within an OnPaint event handler.

See also

wxRegion, wxRegionIterator, wxWindow::OnPaint

### wxWindow::GetWindowStyleFlag

long GetWindowStyleFlag() const

Gets the window style that was passed to the consructor or Create member.

### wxWindow::InitDialog

void InitDialog()

Sends an wxWindow::OnInitDialog event, which in turn transfers data to the dialog via validators.

See also

wxWindow::OnInitDialog

### wxWindow::IsEnabled

virtual bool IsEnabled() const

Returns TRUE if the window is enabled for input, FALSE otherwise.

See also

wxWindow::Enable

### wxWindow::IsRetained

virtual bool IsRetained() const

Returns TRUE if the window is retained, FALSE otherwise.

Remarks

Retained windows are only available on X platforms.

### wxWindow::IsShown

virtual bool IsShown() const

Returns TRUE if the window is shown, FALSE if it has been hidden.

### wxWindow::Layout

void Layout()

Invokes the constraint-based layout algorithm for this window. It is called automatically by the default wxWindow::OnSize member.

### wxWindow::LoadFromResource

virtual bool LoadFromResource(wxWindow* parent, const wxString& resourceName, const wxResourceTable* resourceTable = NULL)

Loads a panel or dialog from a resource file.

Parameters

parent

Parent window.

resourceName

The name of the resource to load.

resourceTable

The resource table to load it from. If this is NULL, the default resource table will be used.

Return value

TRUE if the operation succeeded, otherwise FALSE.

### wxWindow::Lower

void Lower()

Lowers the window to the bottom of the window hierarchy if it is a managed window (dialog or frame).

### wxWindow::MakeModal

virtual void MakeModal(const bool flag)

Disables all other windows in the application so that the user can only interact with this window.

Parameters

flag

If TRUE, this call disables all other windows in the application so that the user can only interact with this window. If FALSE, the effect is reversed.

### wxWindow::Move

void Move(int x, int y)

void Move(const wxPoint& pt)

Moves the window to the given position.

Parameters

x

Required x position.

y

Required y position.

pt

wxPoint object representing the position.

Remarks

Implementations of SetSize can also implicitly implement the wxWindow::Move function, which is defined in the base wxWindow class as the call:

      SetSize(x, y, -1, -1, wxSIZE_USE_EXISTING);

See also

wxWindow::SetSize

wxPython note:
In place of a single overloaded method name, wxPython implements the following methods:

Move(point) | Accepts a wxPoint
MoveXY(x, y) | Accepts a pair of integers

### wxWindow::OnActivate

void OnActivate(wxActivateEvent& event)

Called when a window is activated or deactivated.

Parameters

event

Object containing activation information.

Remarks

If the window is being activated, wxActivateEvent::GetActive returns TRUE, otherwise it returns FALSE (it is being deactivated).

See also

wxActivateEvent, Event handling overview

### wxWindow::OnChar

void OnChar(wxKeyEvent& event)

Called when the user has pressed a key that is not a modifier (SHIFT, CONTROL or ALT).

Parameters

event

Object containing keypress information. See wxKeyEvent for details about this class.

Remarks

This member function is called in response to a keypress. To intercept this event, use the EVT_CHAR macro in an event table definition. Your OnChar handler may call this default function to achieve default keypress functionality.

Note that the ASCII values do not have explicit key codes: they are passed as ASCII values.

Note that not all keypresses can be intercepted this way. If you wish to intercept modifier keypresses, then you will need to use wxWindow::OnKeyDown or wxWindow::OnKeyUp.

Most, but not all, windows allow keypresses to be intercepted.

See also

wxWindow::OnKeyDown, wxWindow::OnKeyUp, wxKeyEvent, wxWindow::OnCharHook, Event handling overview

### wxWindow::OnCharHook

void OnCharHook(wxKeyEvent& event)

This member is called to allow the window to intercept keyboard events before they are processed by child windows.

Parameters

event

Object containing keypress information. See wxKeyEvent for details about this class.

Remarks

This member function is called in response to a keypress, if the window is active. To intercept this event, use the EVT_CHAR_HOOK macro in an event table definition. If you do not process a particular keypress, call wxEvent::Skip to allow default processing.

An example of using this function is in the implementation of escape-character processing for wxDialog, where pressing ESC dismisses the dialog by OnCharHook 'forging' a cancel button press event.

Note that the ASCII values do not have explicit key codes: they are passed as ASCII values.

This function is only relevant to top-level windows (frames and dialogs), and under Windows only.

See also

wxKeyEvent, wxWindow::OnCharHook, wxApp::OnCharHook, Event handling overview

### wxWindow::OnCommand

virtual void OnCommand(wxEvtHandler& object, wxCommandEvent& event)

This virtual member function is called if the control does not handle the command event.

Parameters

object

Object receiving the command event.

event

Command event

Remarks

This virtual function is provided mainly for backward compatibility. You can also intercept commands from child controls by using an event table, with identifiers or identifier ranges to identify the control(s) in question.

See also

wxCommandEvent, Event handling overview

### wxWindow::OnClose

virtual bool OnClose()

Called when the user has tried to close a a frame or dialog box using the window manager (X) or system menu (Windows).

Note: This is an obsolete function. It is superceded by the wxWindow::OnCloseWindow event handler.

Return value

If TRUE is returned by OnClose, the window will be deleted by the system, otherwise the attempt will be ignored. Do not delete the window from within this handler, although you may delete other windows.

See also

Window deletion overview, wxWindow::Close, wxWindow::OnCloseWindow, wxCloseEvent

### wxWindow::OnCloseWindow

void OnCloseWindow(wxCloseEvent& event)

This is an event handler function called when the user has tried to close a a frame or dialog box using the window manager (X) or system menu (Windows). It is called via the wxWindow::Close function, so that the application can also invoke the handler programmatically.

Use the EVT_CLOSE event table macro to handle close events.

You should check whether the application is forcing the deletion of the window using wxCloseEvent::GetForce. If this is TRUE, destroy the window using wxWindow::Destroy. If not, it is up to you whether you respond by destroying the window.

(Note: GetForce is now superceded by CanVeto. So to test whether forced destruction of the window is required, test for the negative of CanVeto. If CanVeto returns FALSE, it is not possible to skip window deletion.)

If you don't destroy the window, you should call wxCloseEvent::Veto to let the calling code know that you did not destroy the window. This allows the wxWindow::Close function to return TRUE or FALSE depending on whether the close instruction was honoured or not.

Remarks

The wxWindow::OnClose virtual function remains for backward compatibility with earlier versions of wxWidgets. The default OnCloseWindow handler for wxFrame and wxDialog will call OnClose, destroying the window if it returns TRUE or if the close is being forced.

See also

Window deletion overview, wxWindow::Close, wxWindow::OnClose, wxWindow::Destroy, wxCloseEvent, wxApp::OnQueryEndSession, wxApp::OnEndSession

### wxWindow::OnDropFiles

void OnDropFiles(wxDropFilesEvent& event)

Called when files have been dragged from the file manager to the window.

Parameters

event

Drop files event. For more information, see wxDropFilesEvent.

Remarks

The window must have previously been enabled for dropping by calling wxWindow::DragAcceptFiles.

This event is only generated under Windows.

To intercept this event, use the EVT_DROP_FILES macro in an event table definition.

See also

wxDropFilesEvent, wxWindow::DragAcceptFiles, Event handling overview

### wxWindow::OnEraseBackground

void OnEraseBackground(wxEraseEvent& event)

Called when the background of the window needs to be erased.

Parameters

event

Erase background event. For more information, see wxEraseEvent.

Remarks

This event is only generated under Windows.

To intercept this event, use the EVT_ERASE_BACKGROUND macro in an event table definition.

See also

wxEraseEvent, Event handling overview

### wxWindow::OnKeyDown

void OnKeyDown(wxKeyEvent& event)

Called when the user has pressed a key, before it is translated into an ASCII value using other modifier keys that might be pressed at the same time.

Parameters

event

Object containing keypress information. See wxKeyEvent for details about this class.

Remarks

This member function is called in response to a key down event. To intercept this event, use the EVT_KEY_DOWN macro in an event table definition. Your OnKeyDown handler may call this default function to achieve default keypress functionality.

Note that not all keypresses can be intercepted this way. If you wish to intercept special keys, such as shift, control, and function keys, then you will need to use wxWindow::OnKeyDown or wxWindow::OnKeyUp.

Most, but not all, windows allow keypresses to be intercepted.

See also

wxWindow::OnChar, wxWindow::OnKeyUp, wxKeyEvent, wxWindow::OnCharHook, Event handling overview

### wxWindow::OnKeyUp

void OnKeyUp(wxKeyEvent& event)

Called when the user has released a key.

Parameters

event

Object containing keypress information. See wxKeyEvent for details about this class.

Remarks

This member function is called in response to a key up event. To intercept this event, use the EVT_KEY_UP macro in an event table definition. Your OnKeyUp handler may call this default function to achieve default keypress functionality.

Note that not all keypresses can be intercepted this way. If you wish to intercept special keys, such as shift, control, and function keys, then you will need to use wxWindow::OnKeyDown or wxWindow::OnKeyUp.

Most, but not all, windows allow key up events to be intercepted.

See also

wxWindow::OnChar, wxWindow::OnKeyDown, wxKeyEvent, wxWindow::OnCharHook, Event handling overview

### wxWindow::OnKillFocus

void OnKillFocus(wxFocusEvent& event)

Called when a window's focus is being killed.

Parameters

event

The focus event. For more information, see wxFocusEvent.

Remarks

To intercept this event, use the macro EVT_KILL_FOCUS in an event table definition.

Most, but not all, windows respond to this event.

See also

wxFocusEvent, wxWindow::OnSetFocus, Event handling overview

### wxWindow::OnIdle

void OnIdle(wxIdleEvent& event)

Provide this member function for any processing which needs to be done when the application is idle.

See also

wxApp::OnIdle, wxIdleEvent

### wxWindow::OnInitDialog

void OnInitDialog(wxInitDialogEvent& event)

Default handler for the wxEVT_INIT_DIALOG event. Calls wxWindow::TransferDataToWindow.

Parameters

event

Dialog initialisation event.

Remarks

Gives the window the default behaviour of transferring data to child controls via the validator that each control has.

See also

wxValidator, wxWindow::TransferDataToWindow

### wxWindow::OnMenuCommand

void OnMenuCommand(wxCommandEvent& event)

Called when a menu command is received from a menu bar.

Parameters

event

The menu command event. For more information, see wxCommandEvent.

Remarks

A function with this name doesn't actually exist; you can choose any member function to receive menu command events, using the EVT_COMMAND macro for individual commands or EVT_COMMAND_RANGE for a range of commands.

See also

wxCommandEvent, wxWindow::OnMenuHighlight, Event handling overview

### wxWindow::OnMenuHighlight

void OnMenuHighlight(wxMenuEvent& event)

Called when a menu select is received from a menu bar: that is, the mouse cursor is over a menu item, but the left mouse button has not been pressed.

Parameters

event

The menu highlight event. For more information, see wxMenuEvent.

Remarks

You can choose any member function to receive menu select events, using the EVT_MENU_HIGHLIGHT macro for individual menu items or EVT_MENU_HIGHLIGHT_ALL macro for all menu items.

The default implementation for wxFrame::OnMenuHighlight displays help text in the first field of the status bar.

This function was known as OnMenuSelect in earlier versions of wxWidgets, but this was confusing since a selection is normally a left-click action.

See also

wxMenuEvent, wxWindow::OnMenuCommand, Event handling overview

### wxWindow::OnMouseEvent

void OnMouseEvent(wxMouseEvent& event)

Called when the user has initiated an event with the mouse.

Parameters

event

The mouse event. See wxMouseEvent for more details.

Remarks

Most, but not all, windows respond to this event.

To intercept this event, use the EVT_MOUSE_EVENTS macro in an event table definition, or individual mouse event macros such as EVT_LEFT_DOWN.

See also

wxMouseEvent, Event handling overview

### wxWindow::OnMove

void OnMove(wxMoveEvent& event)

Called when a window is moved.

Parameters

event

The move event. For more information, see wxMoveEvent.

Remarks

Use the EVT_MOVE macro to intercept move events.

Remarks

Not currently implemented.

See also

wxMoveEvent, wxFrame::OnSize, Event handling overview

### wxWindow::OnPaint

void OnPaint(wxPaintEvent& event)

Sent to the event handler when the window must be refreshed.

Parameters

event

Paint event. For more information, see wxPaintEvent.

Remarks

Use the EVT_PAINT macro in an event table definition to intercept paint events.

In a paint event handler, the application should always create a wxPaintDC object.

For example:

      void MyWindow::OnPaint(wxPaintEvent& event)
      {
          wxPaintDC dc(this);

          DrawMyDocument(dc);
      }

You can optimize painting by retrieving the rectangles that have been damaged and only repainting these. The rectangles are in terms of the client area, and are unscrolled, so you will need to do some calculations using the current view position to obtain logical, scrolled units.

Here is an example of using the wxRegionIterator class:

    // Called when window needs to be repainted.
    void MyWindow::OnPaint(wxPaintEvent& event)
    {
      wxPaintDC dc(this);

      // Find Out where the window is scrolled to
      int vbX,vbY;                     // Top left corner of client
      ViewStart(&vbX,&vbY);

      int vX,vY,vW,vH;                 // Dimensions of client area in pixels
      wxRegionIterator upd(GetUpdateRegion()); // get the update rect list

      while (upd)
      {
        vX = upd.GetX();
        vY = upd.GetY();
        vW = upd.GetW();
        vH = upd.GetH();

        // Alternatively we can do this:
        // wxRect rect;
        // upd.GetRect(&rect);

        // Repaint this rectangle
        ...some code...

        upd ++ ;
      }
    }

See also

wxPaintEvent, wxPaintDC, Event handling overview

### wxWindow::OnScroll

void OnScroll(wxScrollEvent& event)

Called when a scroll event is received from one of the window's built-in scrollbars.

Parameters

event

Command event. Retrieve the new scroll position by calling wxScrollEvent::GetPosition, and the scrollbar orientation by calling wxScrollEvent::GetOrientation.

Remarks

Note that it is not possible to distinguish between horizontal and vertical scrollbars until the function is executing (you can't have one function for vertical, another for horizontal events).

See also

wxScrollEvent, Event handling overview

### wxWindow::OnSetFocus

void OnSetFocus(wxFocusEvent& event)

Called when a window's focus is being set.

Parameters

event

The focus event. For more information, see wxFocusEvent.

Remarks

To intercept this event, use the macro EVT_SET_FOCUS in an event table definition.

Most, but not all, windows respond to this event.

See also

wxFocusEvent, wxWindow::OnKillFocus, Event handling overview

### wxWindow::OnSize

void OnSize(wxSizeEvent& event)

Called when the window has been resized.

Parameters

event

Size event. For more information, see wxSizeEvent.

Remarks

You may wish to use this for frames to resize their child windows as appropriate.

Note that the size passed is of the whole window: call wxWindow::GetClientSize for the area which may be used by the application.

See also

wxSizeEvent, Event handling overview

### wxWindow::OnSysColourChanged

void OnSysColourChanged(wxOnSysColourChangedEvent& event)

Called when the user has changed the system colours.

Parameters

event

System colour change event. For more information, see wxSysColourChangedEvent.

See also

wxSysColourChangedEvent, Event handling overview

### wxWindow::PopEventHandler

wxEvtHandler* PopEventHandler(bool deleteHandler = FALSE) const

Removes and returns the top-most event handler on the event handler stack.

Parameters

deleteHandler

If this is TRUE, the handler will be deleted after it is removed. The default value is FALSE.

See also

wxWindow::SetEventHandler, wxWindow::GetEventHandler, wxWindow::PushEventHandler, wxEvtHandler::ProcessEvent, wxEvtHandler

### wxWindow::PopupMenu

virtual bool PopupMenu(wxMenu* menu, int x, int y)

Pops up the given menu at the specified coordinates, relative to this window, and returns control when the user has dismissed the menu. If a menu item is selected, the callback defined for the menu is called with wxMenu and wxCommandEvent reference arguments. The callback should access the commandInt member of the event to check the selected menu identifier.

Parameters

menu

Menu to pop up.

x

Required x position for the menu to appear.

y

Required y position for the menu to appear.

See also

wxMenu

Remarks

Just before the menu is popped up, wxMenu::UpdateUI is called to ensure that the menu items are in the correct state.

### wxWindow::PushEventHandler

void PushEventHandler(wxEvtHandler* handler)

Pushes this event handler onto the event stack for the window.

Parameters

handler

Specifies the handler to be pushed.

Remarks

An event handler is an object that is capable of processing the events sent to a window. By default, the window is its own event handler, but an application may wish to substitute another, for example to allow central implementation of event-handling for a variety of different window classes.

wxWindow::PushEventHandler allows an application to set up a chain of event handlers, where an event not handled by one event handler is handed to the next one in the chain. Use wxWindow::PopEventHandler to remove the event handler.

See also

wxWindow::SetEventHandler, wxWindow::GetEventHandler, wxWindow::PopEventHandler, wxEvtHandler::ProcessEvent, wxEvtHandler

### wxWindow::Raise

void Raise()

Raises the window to the top of the window hierarchy if it is a managed window (dialog or frame).

### wxWindow::Refresh

virtual void Refresh(const bool eraseBackground = TRUE, const wxRect* rect = NULL)

Causes a message or event to be generated to repaint the window.

Parameters

eraseBackground

If TRUE, the background will be erased.

rect

If non-NULL, only the given rectangle will be treated as damaged.

### wxWindow::ReleaseMouse

virtual void ReleaseMouse()

Releases mouse input captured with wxWindow::CaptureMouse.

See also

wxWindow::CaptureMouse

### wxWindow::RemoveChild

virtual void RemoveChild(wxWindow* child)

Removes a child window. This is called automatically by window deletion functions so should not be required by the application programmer.

Parameters

child

Child window to remove.

### wxWindow::ScreenToClient

virtual void ScreenToClient(int* x, int* y) const

virtual wxPoint ScreenToClient(const wxPoint& pt) const

Converts from screen to client window coordinates.

Parameters

x

Stores the screen x coordinate and receives the client x coordinate.

y

Stores the screen x coordinate and receives the client x coordinate.

pt

The screen position for the second form of the function.

wxPython note:
In place of a single overloaded method name, wxPython implements the following methods:

ScreenToClient(point) | Accepts and returns a wxPoint
ScreenToClientXY(x, y) | Returns a 2-tuple, (x, y)

### wxWindow::ScrollWindow

virtual void ScrollWindow(int dx, int dy, const wxRect* rect = NULL)

Physically scrolls the pixels in the window.

Parameters

dx

Amount to scroll horizontally.

dy

Amount to scroll vertically.

rect

Rectangle to invalidate. If this is NULL, the whole window is invalidated. If you pass a rectangle corresponding to the area of the window exposed by the scroll, your painting handler can optimise painting by checking for the invalidated region.

Remarks

Available only under Windows.

Use this function to optimise your scrolling implementations, to minimise the area that must be redrawn.

### wxWindow::SetAcceleratorTable

virtual void SetAcceleratorTable(const wxAcceleratorTable& accel)

Sets the accelerator table for this window. See wxAcceleratorTable.

### wxWindow::SetAutoLayout

void SetAutoLayout(const bool autoLayout)

Determines whether the wxWindow::Layout function will be called automatically when the window is resized.

Parameters

autoLayout

Set this to TRUE if you wish the Layout function to be called from within wxWindow::OnSize functions.

See also

wxWindow::SetConstraints

### wxWindow::SetBackgroundColour

virtual void SetBackgroundColour(const wxColour& colour)

Sets the background colour of the window.

Parameters

colour

The colour to be used as the background colour.

Remarks

The background colour is usually painted by the default wxWindow::OnEraseBackground event handler function.

Note that setting the background colour does not cause an immediate refresh, so you may wish to call wxWindow::Clear or wxWindow::Refresh after calling this function.

See also

wxWindow::GetBackgroundColour, wxWindow::SetForegroundColour, wxWindow::GetForegroundColour, wxWindow::Clear, wxWindow::Refresh, wxWindow::OnEraseBackground

### wxWindow::SetClientSize

virtual void SetClientSize(int width, int height)

virtual void SetClientSize(const wxSize& size)

This sets the size of the window client area in pixels. Using this function to size a window tends to be more device-independent than wxWindow::SetSize, since the application need not worry about what dimensions the border or title bar have when trying to fit the window around panel items, for example.

Parameters

width

The required client area width.

height

The required client area height.

size

The required client size.

wxPython note:
In place of a single overloaded method name, wxPython implements the following methods:

SetClientSize(size) | Accepts a wxSize
SetClientSizeWH(width, height) |

### wxWindow::SetCursor

virtual void SetCursor(const wxCursor&cursor)

Sets the window's cursor. Notice that setting the cursor for this window does not set it for its children so you'll need to explicitly call SetCursor() for them too if you need it.

Parameters

cursor

Specifies the cursor that the window should normally display.

See also

::wxSetCursor, wxCursor

### wxWindow::SetEventHandler

void SetEventHandler(wxEvtHandler* handler)

Sets the event handler for this window.

Parameters

handler

Specifies the handler to be set.

Remarks

An event handler is an object that is capable of processing the events sent to a window. By default, the window is its own event handler, but an application may wish to substitute another, for example to allow central implementation of event-handling for a variety of different window classes.

It is usually better to use wxWindow::PushEventHandler since this sets up a chain of event handlers, where an event not handled by one event handler is handed to the next one in the chain.

See also

wxWindow::GetEventHandler, wxWindow::PushEventHandler, wxWindow::PopEventHandler, wxEvtHandler::ProcessEvent, wxEvtHandler

### wxWindow::SetConstraints

void SetConstraints(wxLayoutConstraints* constraints)

Sets the window to have the given layout constraints. The window will then own the object, and will take care of its deletion. If an existing layout constraints object is already owned by the window, it will be deleted.

Parameters

constraints

The constraints to set. Pass NULL to disassociate and delete the window's constraints.

Remarks

You must call wxWindow::SetAutoLayout to tell a window to use the constraints automatically in OnSize; otherwise, you must override OnSize and call Layout explicitly.

### wxWindow::SetDropTarget

void SetDropTarget(wxDropTarget* target)

Associates a drop target with this window.

If the window already has a drop target, it is deleted.

See also

wxWindow::GetDropTarget, Drag and drop overview

### wxWindow::SetFocus

virtual void SetFocus()

This sets the window to receive keyboard input.

### wxWindow::SetFont

void SetFont(const wxFont& font)

Sets the font for this window.

Parameters

font

Font to associate with this window.

See also

wxWindow::GetFont

### wxWindow::SetForegroundColour

virtual void SetForegroundColour(const wxColour& colour)

Sets the foreground colour of the window.

Parameters

colour

The colour to be used as the foreground colour.

Remarks

The interpretation of foreground colour is open to interpretation according to the window class; it may be the text colour or other colour, or it may not be used at all.

See also

wxWindow::GetForegroundColour, wxWindow::SetBackgroundColour, wxWindow::GetBackgroundColour

### wxWindow::SetId

void SetId(int id)

Sets the identifier of the window.

Remarks

Each window has an integer identifier. If the application has not provided one, an identifier will be generated. Normally, the identifier should be provided on creation and should not be modified subsequently.

See also

wxWindow::GetId, Window identifiers

### wxWindow::SetName

virtual void SetName(const wxString& name)

Sets the window's name.

Parameters

name

A name to set for the window.

See also

wxWindow::GetName

### wxWindow::SetPalette

virtual void SetPalette(wxPalette* palette)

Obsolete - use wxDC::SetPalette instead.

### wxWindow::SetReturnCode

void SetReturnCode(int retCode)

Sets the return code for this window.

Parameters

retCode

The integer return code, usually a control identifier.

Remarks

A return code is normally associated with a modal dialog, where wxDialog::ShowModal returns a code to the application. The function wxDialog::EndModal calls SetReturnCode.

See also

wxWindow::GetReturnCode, wxDialog::ShowModal, wxDialog::EndModal

### wxWindow::SetScrollbar

virtual void SetScrollbar(int orientation, int position, int thumbSize, int range, const bool refresh = TRUE)

Sets the scrollbar properties of a built-in scrollbar.

Parameters

orientation

Determines the scrollbar whose page size is to be set. May be wxHORIZONTAL or wxVERTICAL.

position

The position of the scrollbar in scroll units.

thumbSize

The size of the thumb, or visible portion of the scrollbar, in scroll units.

range

The maximum position of the scrollbar.

refresh

TRUE to redraw the scrollbar, FALSE otherwise.

Remarks

Let's say you wish to display 50 lines of text, using the same font. The window is sized so that you can only see 16 lines at a time.

You would use:

      SetScrollbar(wxVERTICAL, 0, 16, 50);

Note that with the window at this size, the thumb position can never go above 50 minus 16, or 34.

You can determine how many lines are currently visible by dividing the current view size by the character height in pixels.

When defining your own scrollbar behaviour, you will always need to recalculate the scrollbar settings when the window size changes. You could therefore put your scrollbar calculations and SetScrollbar call into a function named AdjustScrollbars, which can be called initially and also from your wxWindow::OnSize event handler function.

See also

Scrolling overview, wxScrollBar, wxScrolledWindow

### wxWindow::SetScrollPos

virtual void SetScrollPos(int orientation, int pos, const bool refresh = TRUE)

Sets the position of one of the built-in scrollbars.

Parameters

orientation

Determines the scrollbar whose position is to be set. May be wxHORIZONTAL or wxVERTICAL.

pos

Position in scroll units.

refresh

TRUE to redraw the scrollbar, FALSE otherwise.

Remarks

This function does not directly affect the contents of the window: it is up to the application to take note of scrollbar attributes and redraw contents accordingly.

See also

wxWindow::SetScrollbar, wxWindow::GetScrollPos, wxWindow::GetScrollThumb, wxScrollBar, wxScrolledWindow

### wxWindow::SetSize

virtual void SetSize(int x, int y, int width, int height, int sizeFlags = wxSIZE_AUTO)

virtual void SetSize(const wxRect& rect)

Sets the size and position of the window in pixels.

virtual void SetSize(int width, int height)

virtual void SetSize(const wxSize& size)

Sets the size of the window in pixels.

Parameters

x

Required x position in pixels, or -1 to indicate that the existing value should be used.

y

Required y position in pixels, or -1 to indicate that the existing value should be used.

width

Required width in pixels, or -1 to indicate that the existing value should be used.

height

Required height position in pixels, or -1 to indicate that the existing value should be used.

size

wxSize object for setting the size.

rect

wxRect object for setting the position and size.

sizeFlags

Indicates the interpretation of other parameters. It is a bit list of the following:

wxSIZE_AUTO_WIDTH: a -1 width value is taken to indicate a wxWidgets-supplied default width.
wxSIZE_AUTO_HEIGHT: a -1 height value is taken to indicate a wxWidgets-supplied default width.
wxSIZE_AUTO: -1 size values are taken to indicate a wxWidgets-supplied default size.
wxSIZE_USE_EXISTING: existing dimensions should be used if -1 values are supplied.
wxSIZE_ALLOW_MINUS_ONE: allow dimensions of -1 and less to be interpreted as real dimensions, not default values.

Remarks

The second form is a convenience for calling the first form with default x and y parameters, and must be used with non-default width and height values.

The first form sets the position and optionally size, of the window. Parameters may be -1 to indicate either that a default should be supplied by wxWidgets, or that the current value of the dimension should be used.

See also

wxWindow::Move

wxPython note:
In place of a single overloaded method name, wxPython implements the following methods:

SetDimensions(x, y, width, height, sizeFlags=wxSIZE_AUTO) |
SetSize(size) |
SetPosition(point) |

### wxWindow::SetSizeHints

virtual void SetSizeHints(int minW=-1, int minH=-1, int maxW=-1, int maxH=-1, int incW=-1, int incH=-1)

Allows specification of minimum and maximum window sizes, and window size increments. If a pair of values is not set (or set to -1), the default values will be used.

Parameters

minW

Specifies the minimum width allowable.

minH

Specifies the minimum height allowable.

maxW

Specifies the maximum width allowable.

maxH

Specifies the maximum height allowable.

incW

Specifies the increment for sizing the width (Motif/Xt only).

incH

Specifies the increment for sizing the height (Motif/Xt only).

Remarks

If this function is called, the user will not be able to size the window outside the given bounds.

The resizing increments are only significant under Motif or Xt.

### wxWindow::SetTitle

virtual void SetTitle(const wxString& title)

Sets the window's title. Applicable only to frames and dialogs.

Parameters

title

The window's title.

See also

wxWindow::GetTitle

### wxWindow::Show

virtual bool Show(const bool show)

Shows or hides the window.

Parameters

show

If TRUE, displays the window and brings it to the front. Otherwise, hides the window.

See also

wxWindow::IsShown

### wxWindow::TransferDataFromWindow

virtual bool TransferDataFromWindow()

Transfers values from child controls to data areas specified by their validators. Returns FALSE if a transfer failed.

See also

wxWindow::TransferDataToWindow, wxValidator, wxWindow::Validate

### wxWindow::TransferDataToWindow

virtual bool TransferDataToWindow()

Transfers values to child controls from data areas specified by their validators.

Return value

Returns FALSE if a transfer failed.

See also

wxWindow::TransferDataFromWindow, wxValidator, wxWindow::Validate

### wxWindow::Validate

virtual bool Validate()

Validates the current values of the child controls using their validators.

Return value

Returns FALSE if any of the validations failed.

See also

wxWindow::TransferDataFromWindow, wxWindow::TransferDataFromWindow, wxValidator

### wxWindow::WarpPointer

void WarpPointer(int x, int y)

Moves the pointer to the given position on the window.

Parameters

x

The new x position for the cursor.

y

The new y position for the cursor.